#ifndef _CONFIG_H
#define _CONFIG_H

/* (cat tee wc xargs rev split) */
#define BUF_SIZE 2048

/* Random source (shred) */
#define RAND_SOURCE "/dev/urandom"

/* format for printf (head) */
#define HEAD_FMT "==> %s <==\n"

/* mount config */
#define MOUNT_CFG "/etc/fstab"
#define MOUNT_DEF_FS "ext4"
#define MOUNT_LIST "/proc/mounts"
#define MOUNT_OPT_SIZE 512

/* nologin sleep */
#define NOLOGIN_SLEEP 0

/* colors for ls */
#define LS_DIR_COLOR "\033[1;34m"
#define LS_LINK_COLOR "\033[1;35m"
#define LS_SOCK_COLOR "\033[35m"
#define LS_FIFO_COLOR "\033[1;35m"
#define LS_BLOCK_COLOR "\033[1;33m"
#define LS_EXE_COLOR "\033[1;32m"

/* Init scripts */
#ifdef INIT
char *INIT_POWEROFF[] = {"/etc/rc.poweroff", NULL};
char *INIT_START[] = {"/etc/rc.init", NULL};
#define INIT_MSG "Starting micro-init..."
#endif

/* Max args (xargs) */
#ifdef XARGS
#include <limits.h>
#define NARGS ARG_MAX

/* Arg size (xargs) */
#define ARG_SIZE 1024
#endif

/* Default cmd (xargs) */
#define ECHO_CMD "echo"

/* Os name for uname */
/* #define OS_NAME "unknow" */

/* Options: To disable, comment line */

/* getloadavg() unavailable in android */
#ifndef __ANDROID__
#define UPTIME_LOADAVG
#endif

#endif
