#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include "config.h"

void strrev(char *str, off_t len) {
	if (str[len] == '\n')
		len--;

	for (off_t i = 0; i < len; i++, len--) {
		char c = str[i];
		str[i] = str[len];
		str[len] = c;
	}
}

int rev(const char *path) {
	FILE *fp = stdin;

	if (strcmp(path, "-"))
		fp = fopen(path, "r");

	if (fp == NULL) {
		fprintf(stderr, "rev: %s: %s\n", path, strerror(errno));
		return 1;
	}

	char buf[BUF_SIZE + 1];
	while (fgets(buf, sizeof(buf), fp)) {
		strrev(buf, strlen(buf) - 1);
		fputs(buf, stdout);
	}

	putchar('\n');
	if (strcmp(path, "-"))
		fclose(fp);

	return 0;
}

int main(int argc, char **argv) {
	int opt;
	while ((opt = getopt(argc, argv, "")) != -1) {
		printf("rev [file]\n");
		return 0;
	}

	argv += optind;
	argc -= optind;

	if (argc == 0)
		return rev("-");

	else
		return rev(argv[0]);
}

